#include "AM50288H.h"

namespace Tnksoft {
namespace AM50288H {
	AM50288H::AM50288H()
	{
	}

	void AM50288H::begin(byte pinLE, byte pinDIN, byte pinSCK)
	{
		_am.setPins(pinLE, pinDIN, pinSCK);
		_am.begin();
	}

	void AM50288H::update()
	{
		_am.update();
	}

	void AM50288H::clear()
	{
		_am.clear();
	}

	void AM50288H::setSegmentAsBits(int pos, unsigned short segbits)
	{
		_am.setSegmentAsBits(pos, segbits);
	}

	void AM50288H::setSegment(int pos, SegmentPosition spos)
	{
		_am.setSegment(pos, (AM50288H_SegmentPosition)spos);
	}

	unsigned short AM50288H::getAsciiSegment(wchar_t ascii)
	{
		return _am.getAsciiSegment((char)ascii);
	}

	SegmentPosition AM50288H::getSegmentFlag(unsigned short seg)
	{
		return (SegmentPosition)_am.getSegmentFlag(seg);
	}

	void AM50288H::setAscii(int pos, wchar_t ascii)
	{
		_am.setAscii(pos, (char)ascii);
	}

	void AM50288H::setAsciiString(Platform::String ^str)
	{
		auto wp = str->Data();
		int slen = (int)min(8, str->Length());
		char cs[9] = { 0 };
		for (int i = 0; i < slen; i++) {
			cs[i] = (char)wp[i];
		}
		_am.setAsciiString(cs);
	}

	void AM50288H::setMark(Mark mark, bool set)
	{
		_am.setMark((AM50288H_Mark)mark, set);
	}

	void AM50288H::shiftSegments(bool left)
	{
		_am.shiftSegments(left);
	}

	void AM50288H::shiftSegmentsLeft()
	{
		_am.shiftSegmentsLeft();
	}

	void AM50288H::shiftSegmentsRight()
	{
		_am.shiftSegmentsRight();
	}
}
}